X2Go Bug report logs - #566
X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has non-English characters

version graph

Package: x2goclient; Maintainer for x2goclient is X2Go Developers <x2go-dev@lists.x2go.org>; Source for x2goclient is src:x2goclient.

Reported by: <trakatelis@uom.gr>

Date: Mon, 11 Aug 2014 10:55:01 UTC

Severity: grave

Tags: pending

Found in version 4.0.2.1

Fixed in version 4.0.3.0

Done: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 11 Aug 2014 10:55:01 GMT) (full text, mbox, link).


Acknowledgement sent to <trakatelis@uom.gr>:
New Bug report received and forwarded. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 11 Aug 2014 10:55:02 GMT) (full text, mbox, link).


Message #5 received at submit@bugs.x2go.org (full text, mbox, reply):

From: George Trakatelis <trakatelis@gmail.com>
To: <submit@bugs.x2go.org>
Subject: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Mon, 11 Aug 2014 13:51:21 +0300
Package: x2goclient
Version: 4.0.2.1

When I try to connect to a remote server, I cannot get past the pop-up

'Host key verification failed' 

The server is unknown. Do you trust the host key?
Public key hash: xxx.xxx.xxx.xxx:22 -
xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx.xx

no matter how many times I click Yes. The pop-up appears again and again.

It seems that x2goclient cannot create the folder C:\Users\<username>\ssh
and the known_hosts file when <username> has non-English characters.

Confirmed that it works fine when <username> is in English.
  
I'm using Greek Windows 8.1 Pro 64-bit and X2Go Client for Windows
4.0.2.1+hotfix1+build3.



Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 01 Sep 2014 17:30:02 GMT) (full text, mbox, link).


Acknowledgement sent to <trakatelis@uom.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 01 Sep 2014 17:30:02 GMT) (full text, mbox, link).


Message #10 received at 566@bugs.x2go.org (full text, mbox, reply):

From: George Trakatelis <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Subject: RE: Bug#566: Acknowledgement (X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters)
Date: Mon, 1 Sep 2014 20:28:50 +0300
A suggested patch is to substitute the Qt4 toAscii() function with toLocal8Bit() 
in two specific places of SshMasterConnection::run().
A git diff is as follows:

$ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
521c521
<     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toAscii());
---
>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
630c630
<     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toAscii());
---
>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR, (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());

The change affects only Windows builds and was tested in Windows 8.1 Pro and Windows 7 Professional.

G. Trakatelis


-----Original Message-----
From: X2Go Bug Tracking System [mailto:owner@bugs.x2go.org] 
Sent: Monday, August 11, 2014 1:55 PM
To: trakatelis@uom.gr
Subject: Bug#566: Acknowledgement (X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file 
when the local Windows account username has non-English characters)

...

--
566: http://bugs.x2go.org/cgi-bin/bugreport.cgi?bug=566
X2Go Bug Tracking System
Contact owner@bugs.x2go.org with problems


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 01 Sep 2014 19:55:02 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 01 Sep 2014 19:55:02 GMT) (full text, mbox, link).


Message #15 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: trakatelis@uom.gr, 566@bugs.x2go.org, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Mon, 01 Sep 2014 19:51:03 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2,

On  Mo 01 Sep 2014 19:28:50 CEST, George Trakatelis wrote:

> A suggested patch is to substitute the Qt4 toAscii() function with  
> toLocal8Bit()
> in two specific places of SshMasterConnection::run().
> A git diff is as follows:
>
> $ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
> 521c521
> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
> ---
>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
> 630c630
> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
> ---
>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,  
>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>
> The change affects only Windows builds and was tested in Windows 8.1  
> Pro and Windows 7 Professional.
>
> G. Trakatelis

Can you review these changes and if appropriate commit them to the  
master branch of x2goclient.git?

Thanks!
Mike


-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 01 Sep 2014 23:25:02 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 01 Sep 2014 23:25:02 GMT) (full text, mbox, link).


Message #20 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>, 566@bugs.x2go.org
Cc: trakatelis@uom.gr, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Mon, 1 Sep 2014 19:23:12 -0400
On Mon, Sep 1, 2014 at 3:51 PM, Mike Gabriel
<mike.gabriel@das-netzwerkteam.de> wrote:
> Hi Mike#2,
>
> On  Mo 01 Sep 2014 19:28:50 CEST, George Trakatelis wrote:
>
>> A suggested patch is to substitute the Qt4 toAscii() function with
>> toLocal8Bit()
>> in two specific places of SshMasterConnection::run().
>> A git diff is as follows:
>>
>> $ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
>> 521c521
>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>> ---
>>>
>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>
>> 630c630
>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>> ---
>>>
>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>
>>
>> The change affects only Windows builds and was tested in Windows 8.1 Pro
>> and Windows 7 Professional.
>>
>> G. Trakatelis
>
>
> Can you review these changes and if appropriate commit them to the master
> branch of x2goclient.git?
>
> Thanks!
> Mike
>
> [...]

Sure. I'm busy today, but I'll do so within the next few/several days.

-Mike


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sun, 07 Sep 2014 04:45:02 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sun, 07 Sep 2014 04:45:02 GMT) (full text, mbox, link).


Message #25 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>, 566@bugs.x2go.org
Cc: trakatelis@uom.gr, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters
Date: Sun, 7 Sep 2014 00:44:25 -0400
[Message part 1 (text/plain, inline)]
Hi George,

1st, please use either "diff -c" or "git diff" to prepare the patch.
You can even use "git diff" on a files/folders that are outisde of a
git source tree.

2nd, I tried what I think was your patch. I've attached the change I
used, it is outputted with "git diff". I used the x2goclient master
branch (4.0.3.0.)

Unfortunately, it failed to fix the bug. I did not experience any
regressions though.

I tested it on both a Windows XP 32-bit SP3 machine and a Windows 8.1
64-bit machine (with the latest required updates & optional updates
from MS.)

3rd, the username I used was "δοκιμαστικό χρήστη". That is how Google
Translate translated "test user" into Greek. Because it is not easy
for me to type that name into the Windows login prompt, I simply ran
commands like the following to test it:
runas "/user:δοκιμαστικό χρήστη" "c:\x2gobuilds\x2goclient\dist\x2goclient.exe"

-Mike

On Mon, Sep 1, 2014 at 7:23 PM, Michael DePaulo <mikedep333@gmail.com> wrote:
> On Mon, Sep 1, 2014 at 3:51 PM, Mike Gabriel
> <mike.gabriel@das-netzwerkteam.de> wrote:
>> Hi Mike#2,
>>
>> On  Mo 01 Sep 2014 19:28:50 CEST, George Trakatelis wrote:
>>
>>> A suggested patch is to substitute the Qt4 toAscii() function with
>>> toLocal8Bit()
>>> in two specific places of SshMasterConnection::run().
>>> A git diff is as follows:
>>>
>>> $ diff /c/a/sshmasterconnection.cpp /c/b/sshmasterconnection.cpp
>>> 521c521
>>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>>> ---
>>>>
>>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>>
>>> 630c630
>>> <     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>> (mainWnd->getHomeDirectory()+"/ssh").toAscii());
>>> ---
>>>>
>>>>     ssh_options_set ( my_ssh_session, SSH_OPTIONS_SSH_DIR,
>>>> (mainWnd->getHomeDirectory()+"/ssh").toLocal8Bit());
>>>
>>>
>>> The change affects only Windows builds and was tested in Windows 8.1 Pro
>>> and Windows 7 Professional.
>>>
>>> G. Trakatelis
>>
>>
>> Can you review these changes and if appropriate commit them to the master
>> branch of x2goclient.git?
>>
>> Thanks!
>> Mike
>>
>> [...]
>
> Sure. I'm busy today, but I'll do so within the next few/several days.
>
> -Mike
[bug566.test.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sun, 07 Sep 2014 10:05:01 GMT) (full text, mbox, link).


Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sun, 07 Sep 2014 10:05:01 GMT) (full text, mbox, link).


Message #30 received at 566@bugs.x2go.org (full text, mbox, reply):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Sun, 7 Sep 2014 13:04:51 +0300
[Message part 1 (text/plain, inline)]
Hi Mike,

1st, Ok.

2nd, You guessed right, so I have attached the very same file.

3rd, Your findings really puzzled me, so I did the following:

a. Installed German keyboard. Hit ';' to produce an accented letter
and -to my surprise- got ö. So I thought ölexandr was the right name to test for username.

b. Created user ölexandr and logged in as that user.
The patch did not work, as you mentioned.

c. As toLocal8Bit() returns the local 8-bit representation of a string,
I changed the system locale for non-unicode programs to German.
Now the patch worked!

I think the patch solves the problem for the Windows users who use English
as a foreign language and prefer having (non-Ascii) usernames in their native language.

-George

PS. A better title for the bug would be

X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters


-----Αρχικό μήνυμα-----
Από: Michael DePaulo [mailto:mikedep333@gmail.com] 
Αποστολή: Κυριακή, 7 Σεπτεμβρίου 2014 7:44 πμ
Προς: Mike Gabriel; 566@bugs.x2go.org
Κοιν.: trakatelis@uom.gr; George Trakatelis
Θέμα: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters

Hi George,

1st, please use either "diff -c" or "git diff" to prepare the patch.
You can even use "git diff" on a files/folders that are outisde of a git source tree.

2nd, I tried what I think was your patch. I've attached the change I used, it is outputted with "git diff". I used the x2goclient master branch (4.0.3.0.)

Unfortunately, it failed to fix the bug. I did not experience any regressions though.

I tested it on both a Windows XP 32-bit SP3 machine and a Windows 8.1 64-bit machine (with the latest required updates & optional updates from MS.)

3rd, the username I used was "δοκιμαστικό χρήστη". That is how Google Translate translated "test user" into Greek. Because it is not easy for me to type that name into the Windows login prompt, I simply ran commands like the following to test it:
runas "/user:δοκιμαστικό χρήστη" "c:\x2gobuilds\x2goclient\dist\x2goclient.exe"

-Mike
[bug566.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sun, 07 Sep 2014 13:25:01 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sun, 07 Sep 2014 13:25:01 GMT) (full text, mbox, link).


Message #35 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: George Trakatelis <trakatelis@uom.edu.gr>, 566@bugs.x2go.org, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Sun, 7 Sep 2014 09:23:22 -0400
[Message part 1 (text/plain, inline)]
On Sun, Sep 7, 2014 at 6:04 AM, George Trakatelis <trakatelis@uom.edu.gr> wrote:
[...]
>
> a. Installed German keyboard. Hit ';' to produce an accented letter
> and -to my surprise- got ö. So I thought ölexandr was the right name to test for username.
>
> b. Created user ölexandr and logged in as that user.
> The patch did not work, as you mentioned.
>
> c. As toLocal8Bit() returns the local 8-bit representation of a string,
> I changed the system locale for non-unicode programs to German.
> Now the patch worked!
>
> I think the patch solves the problem for the Windows users who use English
> as a foreign language and prefer having (non-Ascii) usernames in their native language.
>
> -George
>
> PS. A better title for the bug would be
>
> X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

Hi Mike#1 and George,

1. What do you think of using toUtf8() instead? I am hoping that will
fix the bug regardless of the locale.

I tried changing it to that (bug566.utf8.test.patch), but it still did
not fix this bug with the greek username on my system with the locale
set to English. It did not introduce a regression for my ASCII user
account at least.

If libssh needs to be recompiled for Unicode, I can do that. I just
recompiled it for bug #590.

FYI: This is the API we are calling:
http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d

2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I
think that we should also change its value from to.Ascii() to
toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for
toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().

-Mike#2
[bug566.test.v2.patch (application/octet-stream, attachment)]
[bug566.utf8.test.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 00:15:02 GMT) (full text, mbox, link).


Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 00:15:02 GMT) (full text, mbox, link).


Message #40 received at 566@bugs.x2go.org (full text, mbox, reply):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>, "'Mike Gabriel'" <mike.gabriel@das-netzwerkteam.de>
Subject: RE: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 8 Sep 2014 03:13:48 +0300
Hi Mike,

1. If you recompile libssh 0.6.3 with Unicode support and provide me with a download link,
I will happily test it on all Windows platforms (namely Windows 8, 7, and XP).

2. I agree.

-George

-----Original Message-----
From: Michael DePaulo [mailto:mikedep333@gmail.com] 
Sent: Sunday, September 7, 2014 4:23 PM
To: George Trakatelis; 566@bugs.x2go.org; Mike Gabriel
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

[...]

Hi Mike#1 and George,

1. What do you think of using toUtf8() instead? I am hoping that will fix the bug regardless of the locale.

I tried changing it to that (bug566.utf8.test.patch), but it still did not fix this bug with the greek username on my system with the locale set to English. It did not introduce a regression for my ASCII user account at least.

If libssh needs to be recompiled for Unicode, I can do that. I just recompiled it for bug #590.

FYI: This is the API we are calling:
http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d

2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I think that we should also change its value from to.Ascii() to
toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().

-Mike#2


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 03:00:02 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 03:00:02 GMT) (full text, mbox, link).


Message #45 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: George Trakatelis <trakatelis@uom.edu.gr>
Cc: 566@bugs.x2go.org, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Sun, 7 Sep 2014 22:55:13 -0400
Yeah. I think that libssh isn't being compiled with Unicode support,
or at least not under MingW 4.4. It's not 100% clear how to compile a
C library with Unicode support under MinGW and CMake. For example,
recent versions of MinGW let you specify the linker option -municode.
But I cannot find a single release note that states when exactly that
feature was added. I do not know if 4.4 has it or not.

I'm going to try to compile it with MinGW 4.8. I've been meaning to
upgrade to X2Go to MinGW 4.8 and QT 4.8.6 anyway. (bug: #474)

On Sun, Sep 7, 2014 at 8:13 PM, George Trakatelis <trakatelis@uom.edu.gr> wrote:
> Hi Mike,
>
> 1. If you recompile libssh 0.6.3 with Unicode support and provide me with a download link,
> I will happily test it on all Windows platforms (namely Windows 8, 7, and XP).
>
> 2. I agree.
>
> -George
>
> -----Original Message-----
> From: Michael DePaulo [mailto:mikedep333@gmail.com]
> Sent: Sunday, September 7, 2014 4:23 PM
> To: George Trakatelis; 566@bugs.x2go.org; Mike Gabriel
> Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
>
> [...]
>
> Hi Mike#1 and George,
>
> 1. What do you think of using toUtf8() instead? I am hoping that will fix the bug regardless of the locale.
>
> I tried changing it to that (bug566.utf8.test.patch), but it still did not fix this bug with the greek username on my system with the locale set to English. It did not introduce a regression for my ASCII user account at least.
>
> If libssh needs to be recompiled for Unicode, I can do that. I just recompiled it for bug #590.
>
> FYI: This is the API we are calling:
> http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d
>
> 2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I think that we should also change its value from to.Ascii() to
> toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().
>
> -Mike#2
>


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 08:55:01 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 08:55:01 GMT) (full text, mbox, link).


Message #50 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: George Trakatelis <trakatelis@uom.edu.gr>, 566@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#566: Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 08 Sep 2014 08:52:31 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2, hi George,

On  So 07 Sep 2014 12:04:51 CEST, George Trakatelis wrote:

> c. As toLocal8Bit() returns the local 8-bit representation of a string,
> I changed the system locale for non-unicode programs to German.
> Now the patch worked!
>
> I think the patch solves the problem for the Windows users who use English
> as a foreign language and prefer having (non-Ascii) usernames in  
> their native language.
>
> -George
>
> PS. A better title for the bug would be
>
> X2Go Client for Windows 4.0.2.1 cannot create  
> C:\Users\<username>\ssh\known_hosts file when the local Windows  
> account username has non-Ascii characters

Now that I think of it more thoroughly... Shouldn't we do a proper  
encode/decode here so that we convert UTF-8 to Windows-CP1251 encoding  
[1]?

Alternatively, one could work with filenames in UTF-16 as shown in  
this [2] example.

I am not sure about the exact position in the code that bugs this up,  
but I fear, the solution is non-trivial.

Either you need to detect the client-side encoding and convert between  
UTF-8 and that encoding, or we may consider addressing file names in  
UTF-16 (if that is possible in Qt).

Unfortunately, it seems that Windows uses different encodings at  
different places (e.g. command.exe vs. Windows Explorer).

Just guessing after a little bit of internet research on this,
Mike#1


[1] http://comments.gmane.org/gmane.comp.lib.qt.general/39868
[2] https://www.mail-archive.com/subsurface@hohndel.org/msg00099.html


-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 08 Sep 2014 09:00:01 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 08 Sep 2014 09:00:02 GMT) (full text, mbox, link).


Message #55 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Michael DePaulo <mikedep333@gmail.com>
Cc: George Trakatelis <trakatelis@uom.edu.gr>, 566@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 08 Sep 2014 08:58:33 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2,

On  So 07 Sep 2014 15:23:22 CEST, Michael DePaulo wrote:

> On Sun, Sep 7, 2014 at 6:04 AM, George Trakatelis  
> <trakatelis@uom.edu.gr> wrote:
> [...]
>>
>> a. Installed German keyboard. Hit ';' to produce an accented letter
>> and -to my surprise- got ö. So I thought ölexandr was the right  
>> name to test for username.
>>
>> b. Created user ölexandr and logged in as that user.
>> The patch did not work, as you mentioned.
>>
>> c. As toLocal8Bit() returns the local 8-bit representation of a string,
>> I changed the system locale for non-unicode programs to German.
>> Now the patch worked!
>>
>> I think the patch solves the problem for the Windows users who use English
>> as a foreign language and prefer having (non-Ascii) usernames in  
>> their native language.
>>
>> -George
>>
>> PS. A better title for the bug would be
>>
>> X2Go Client for Windows 4.0.2.1 cannot create  
>> C:\Users\<username>\ssh\known_hosts file when the local Windows  
>> account username has non-Ascii characters
>
> Hi Mike#1 and George,
>
> 1. What do you think of using toUtf8() instead? I am hoping that will
> fix the bug regardless of the locale.
>
> I tried changing it to that (bug566.utf8.test.patch), but it still did
> not fix this bug with the greek username on my system with the locale
> set to English. It did not introduce a regression for my ASCII user
> account at least.
>
> If libssh needs to be recompiled for Unicode, I can do that. I just
> recompiled it for bug #590.
>
> FYI: This is the API we are calling:
> http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d

I am getting the suspicion, that this is a libssh issue.

X2Go Client and libssh should communicate via UTF-8 (because it is  
_the_ encoding that applications use internally, nowadays) and libssh  
should handle whatever conversion (probably to UTF-16 wide string?) is  
necessary for creating files, being aware of usernames, etc.

> 2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I
> think that we should also change its value from to.Ascii() to
> toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for
> toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().

Same thing. SSH_OPTIONS_USER should be set as UTF-8 and libssh should  
convert to whatever encoding is needed.

Greets,
Mike

-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 09 Sep 2014 13:20:01 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 09 Sep 2014 13:20:02 GMT) (full text, mbox, link).


Message #60 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Cc: George Trakatelis <trakatelis@uom.edu.gr>, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Tue, 9 Sep 2014 09:15:52 -0400
[Message part 1 (text/plain, inline)]
On Mon, Sep 8, 2014 at 4:58 AM, Mike Gabriel
<mike.gabriel@das-netzwerkteam.de> wrote:
> Hi Mike#2,
>
>
> On  So 07 Sep 2014 15:23:22 CEST, Michael DePaulo wrote:
>
>> On Sun, Sep 7, 2014 at 6:04 AM, George Trakatelis <trakatelis@uom.edu.gr>
>> wrote:
>> [...]
>>>
>>>
>>> a. Installed German keyboard. Hit ';' to produce an accented letter
>>> and -to my surprise- got ö. So I thought ölexandr was the right name to
>>> test for username.
>>>
>>> b. Created user ölexandr and logged in as that user.
>>> The patch did not work, as you mentioned.
>>>
>>> c. As toLocal8Bit() returns the local 8-bit representation of a string,
>>> I changed the system locale for non-unicode programs to German.
>>> Now the patch worked!
>>>
>>> I think the patch solves the problem for the Windows users who use
>>> English
>>> as a foreign language and prefer having (non-Ascii) usernames in their
>>> native language.
>>>
>>> -George
>>>
>>> PS. A better title for the bug would be
>>>
>>> X2Go Client for Windows 4.0.2.1 cannot create
>>> C:\Users\<username>\ssh\known_hosts file when the local Windows account
>>> username has non-Ascii characters
>>
>>
>> Hi Mike#1 and George,
>>
>> 1. What do you think of using toUtf8() instead? I am hoping that will
>> fix the bug regardless of the locale.
>>
>> I tried changing it to that (bug566.utf8.test.patch), but it still did
>> not fix this bug with the greek username on my system with the locale
>> set to English. It did not introduce a regression for my ASCII user
>> account at least.
>>
>> If libssh needs to be recompiled for Unicode, I can do that. I just
>> recompiled it for bug #590.
>>
>> FYI: This is the API we are calling:
>>
>> http://api.libssh.org/stable/group__libssh__session.html#ga7a801b85800baa3f4e16f5b47db0a73d
>
>
> I am getting the suspicion, that this is a libssh issue.
>
> X2Go Client and libssh should communicate via UTF-8 (because it is _the_
> encoding that applications use internally, nowadays) and libssh should
> handle whatever conversion (probably to UTF-16 wide string?) is necessary
> for creating files, being aware of usernames, etc.
>
>> 2. in sshmasterconnection.cpp, we also set "SSH_OPTIONS_USER" . I
>> think that we should also change its value from to.Ascii() to
>> toLocal8Bit() or toUtf8(). bug566.test.v2.patch has this change for
>> toLocal8Bit(), and bug566.utf8.test.patch has it for toUtf8().
>
>
> Same thing. SSH_OPTIONS_USER should be set as UTF-8 and libssh should
> convert to whatever encoding is needed.
>
> Greets,
> Mike
[...]

Hi Mike#1 and George,

1.

I believe the best approach is to try to compile libssh with unicode
support, and pass unicode values to it. There is no guarantee that a
user's username (and home dir path) is in the same language as the
language that is set for non-Unicode programs. After all, the
"Language for non-Unicode programs" is called the "system locale", it
applies to all users on the system.

If we have to for the 4.0.3.0 release of x2goclient, we should fix
this bug for the system locale only, and then fix the bug for all
languages/locales later.

2.

See bug 474 for George's patch for compiling libssh with MinGW 4.8.2.
It worked :)

3.

I made some progress compiling libssh 0.6.3 with Unicode support.

With MinGW 4.4, when I specified the following values in CMAKE, libssh
built successfully, but it did not seem to change anything.
CMAKE_EXE_LINKER_FLAGS:STRING=-municode
CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
CMAKE_STATIC_LINKER_FLAGS:STRING=-municode

With MinGW 4.8.2, when I specify those values, libssh fails to build.
I've attached the output.

This is a positive sign because it implies that MinGW 4.8.2 supports
-municode, whereas MinGW 4.4 did not.

I plan to try to resolve this build failure later tonight.

-Mike#2
[libssh-0.6.3-fails-to-build-mingw4.8.2-and--municode.txt (text/plain, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Thu, 11 Sep 2014 12:15:02 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 11 Sep 2014 12:15:02 GMT) (full text, mbox, link).


Message #65 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Subject: Successful compile, but no bugfix
Date: Thu, 11 Sep 2014 08:12:34 -0400
I managed to compile libssh successfully, but I am not sure if it
actually is compiled with unicode support. I say this because the utf8
patch does not fix this bug.

My friend Mike Frederick expressed interest in helping me, so here are
all the details of how I built:

As mentioned in bug 474, I am using this build of mingw 4.8.2, which
QT 4.8.6 wants:
http://sourceforge.net/projects/mingw-w64/files/Toolchains%20targetting%20Win32/Personal%20Builds/mingw-builds/4.8.2/threads-posix/dwarf/i686-4.8.2-release-posix-dwarf-rt_v3-rev3.7z/download

I am using CMake 2.8.12.2 (the latest 2.x version):
http://www.cmake.org/files/v2.8/cmake-2.8.12.2-win32-x86.exe

openssl 1.0.1i
http://slproweb.com/download/Win32OpenSSL-1_0_1i.exe

zlib 1.2.8
http://zlib.net/zlib128-dll.zip

These are the CMake options I specified:
CMAKE_CXX_FLAGS:STRING=-DUNICODE -D_UNICODE
CMAKE_C_FLAGS:STRING=-DUNICODE -D_UNICODE
CMAKE_EXE_LINKER_FLAGS:STRING=-municode
CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
CMAKE_STATIC_LINKER_FLAGS:STRING=-municode
WITH_EXAMPLES:BOOL=OFF
(In addition to specifying ZLIB_ROOT_DIR)

The exact source I am using is this tarball:
http://code.x2go.org/releases/source/libssh-modified-by-x2go-project/libssh-0.6.3-762055b-pageant-support-mingw482.src.zip

Which is libssh-0.6.3 with these 2 patches applied:
http://code.x2go.org/releases/source/libssh-modified-by-x2go-project/implement-support-for-putty-s-pageant-0.6.3-de62963.patch
http://code.x2go.org/releases/source/libssh-modified-by-x2go-project/libssh-0.6.3-pthread.c.relativepaths.patch


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Thu, 11 Sep 2014 19:15:02 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 11 Sep 2014 19:15:02 GMT) (full text, mbox, link).


Message #70 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: Michael DePaulo <mikedep333@gmail.com>, 566@bugs.x2go.org
Subject: Re: [X2Go-Dev] Bug#566: Successful compile, but no bugfix
Date: Thu, 11 Sep 2014 19:11:15 +0000
[Message part 1 (text/plain, inline)]
Hi Mike#2,

On  Do 11 Sep 2014 14:12:34 CEST, Michael DePaulo wrote:

> My friend Mike Frederick expressed interest in helping me, so here are
> all the details of how I built:

/me waves to "Mike#3"!!!

Mike#1

-- 

DAS-NETZWERKTEAM
mike gabriel, herweg 7, 24357 fleckeby
fon: +49 (1520) 1976 148

GnuPG Key ID 0x25771B31
mail: mike.gabriel@das-netzwerkteam.de, http://das-netzwerkteam.de

freeBusy:
https://mail.das-netzwerkteam.de/freebusy/m.gabriel%40das-netzwerkteam.de.xfb
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 15 Sep 2014 05:30:01 GMT) (full text, mbox, link).


Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 15 Sep 2014 05:30:02 GMT) (full text, mbox, link).


Message #75 received at 566@bugs.x2go.org (full text, mbox, reply):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>
Subject: RE: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 15 Sep 2014 08:26:40 +0300
Dear Mike,

I have built libssh 0.6.3 in Visual Studio 2013 (with UNICODE and _UNICODE defined in all projects)
and debugged a tiny test app with function calls analogous to those used in x2goclient.
I'm afraid preprocessor definitions are not enough to make an application/program/library support Unicode.
One could migrate existing programs following a list of guidelines

http://msdn.microsoft.com/en-us/library/cc194801.aspx

For example, a function that fails in libssh (used in ssh_path_expand_tilde(), 
which is always called to replace a ~ with the actual home folder path in a string) is strdup.
To make libssh unicode-friendly strdup has to be replaced by _strdup

http://msdn.microsoft.com/en-us/library/y471khhc.aspx

_strdup would benefit from preprocessor definitions for Unicode support
as it would be converted to the proper Unicode function.

Imho, the only option for now is patch "bug566.test.v2.patch"
as it corrects the problem in the vast majority of Windows installations.
Remember that foreign Windows installations set by default the 
"Language for non-Unicode programs" to that particular foreign language.

-George

-----Original Message-----
From: Michael DePaulo [mailto:mikedep333@gmail.com] 
Sent: Tuesday, September 9, 2014 4:16 PM
To: 566@bugs.x2go.org
Cc: George Trakatelis; Mike Gabriel
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

[...]

Hi Mike#1 and George,

1.

I believe the best approach is to try to compile libssh with unicode support, and pass unicode values to it. There is no guarantee that a user's username (and home dir path) is in the same language as the language that is set for non-Unicode programs. After all, the "Language for non-Unicode programs" is called the "system locale", it applies to all users on the system.

If we have to for the 4.0.3.0 release of x2goclient, we should fix this bug for the system locale only, and then fix the bug for all languages/locales later.

2.

See bug 474 for George's patch for compiling libssh with MinGW 4.8.2.
It worked :)

3.

I made some progress compiling libssh 0.6.3 with Unicode support.

With MinGW 4.4, when I specified the following values in CMAKE, libssh built successfully, but it did not seem to change anything.
CMAKE_EXE_LINKER_FLAGS:STRING=-municode
CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
CMAKE_STATIC_LINKER_FLAGS:STRING=-municode

With MinGW 4.8.2, when I specify those values, libssh fails to build.
I've attached the output.

This is a positive sign because it implies that MinGW 4.8.2 supports -municode, whereas MinGW 4.4 did not.

I plan to try to resolve this build failure later tonight.

-Mike#2


Changed Bug title to 'X2Go Client for Windows cannot create' from 'X2Go Client for Windows 4.0.2.1 cannon create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-English characters' Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Mon, 15 Sep 2014 16:30:01 GMT) (full text, mbox, link).


Bug 566 cloned as bug 611 Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Mon, 15 Sep 2014 16:30:01 GMT) (full text, mbox, link).


Changed Bug title to '"X2Go Client for Windows cannot create' from 'X2Go Client for Windows cannot create' Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Mon, 15 Sep 2014 16:35:02 GMT) (full text, mbox, link).


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Mon, 15 Sep 2014 16:40:01 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Mon, 15 Sep 2014 16:40:01 GMT) (full text, mbox, link).


Message #86 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Cc: Michael Frederick <psududemike@gmail.com>, George Trakatelis <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Mon, 15 Sep 2014 12:38:22 -0400
Control: severity 566 grave

Dear George,

Thank you for your research.

Over the next day or so, I will apply bug566.test.v2.patch, which will
then be included in both the MinGW 4.4 and the MinGW 4.8 nightly
builds. Once you (or someone else) confirms that the patch fixes this
bug for said installations, I will mark this bug as fixed. I've
already cloned this bug. The clone will be for handling languages
other than the "Language for non-Unicode programs"; i.e., using
Unicode.

I am marking this original bug as severity "grave" because it "makes
the package in question unusable or mostly so"[1] for a significant
number of users. Getting this original bug fixed for x2goclient
4.0.3.0 will be a high priority for me.

Also, I tried to shorten the title of this bug (and correct a typo:
cannon -> cannot) but I ran into a bug with the debbugs software. I'm
trying to correct the title.

-Mike

[1] http://bugs.x2go.org/Developer.html#severities

On Mon, Sep 15, 2014 at 1:26 AM, George Trakatelis
<trakatelis@uom.edu.gr> wrote:
> Dear Mike,
>
> I have built libssh 0.6.3 in Visual Studio 2013 (with UNICODE and _UNICODE defined in all projects)
> and debugged a tiny test app with function calls analogous to those used in x2goclient.
> I'm afraid preprocessor definitions are not enough to make an application/program/library support Unicode.
> One could migrate existing programs following a list of guidelines
>
> http://msdn.microsoft.com/en-us/library/cc194801.aspx
>
> For example, a function that fails in libssh (used in ssh_path_expand_tilde(),
> which is always called to replace a ~ with the actual home folder path in a string) is strdup.
> To make libssh unicode-friendly strdup has to be replaced by _strdup
>
> http://msdn.microsoft.com/en-us/library/y471khhc.aspx
>
> _strdup would benefit from preprocessor definitions for Unicode support
> as it would be converted to the proper Unicode function.
>
> Imho, the only option for now is patch "bug566.test.v2.patch"
> as it corrects the problem in the vast majority of Windows installations.
> Remember that foreign Windows installations set by default the
> "Language for non-Unicode programs" to that particular foreign language.
>
> -George
>
> -----Original Message-----
> From: Michael DePaulo [mailto:mikedep333@gmail.com]
> Sent: Tuesday, September 9, 2014 4:16 PM
> To: 566@bugs.x2go.org
> Cc: George Trakatelis; Mike Gabriel
> Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
>
> [...]
>
> Hi Mike#1 and George,
>
> 1.
>
> I believe the best approach is to try to compile libssh with unicode support, and pass unicode values to it. There is no guarantee that a user's username (and home dir path) is in the same language as the language that is set for non-Unicode programs. After all, the "Language for non-Unicode programs" is called the "system locale", it applies to all users on the system.
>
> If we have to for the 4.0.3.0 release of x2goclient, we should fix this bug for the system locale only, and then fix the bug for all languages/locales later.
>
> 2.
>
> See bug 474 for George's patch for compiling libssh with MinGW 4.8.2.
> It worked :)
>
> 3.
>
> I made some progress compiling libssh 0.6.3 with Unicode support.
>
> With MinGW 4.4, when I specified the following values in CMAKE, libssh built successfully, but it did not seem to change anything.
> CMAKE_EXE_LINKER_FLAGS:STRING=-municode
> CMAKE_MODULE_LINKER_FLAGS:STRING=-municode
> CMAKE_SHARED_LINKER_FLAGS:STRING=-municode
> CMAKE_STATIC_LINKER_FLAGS:STRING=-municode
>
> With MinGW 4.8.2, when I specify those values, libssh fails to build.
> I've attached the output.
>
> This is a positive sign because it implies that MinGW 4.8.2 supports -municode, whereas MinGW 4.4 did not.
>
> I plan to try to resolve this build failure later tonight.
>
> -Mike#2
>


Severity set to 'grave' from 'normal' Request was from Michael DePaulo <mikedep333@gmail.com> to 566-submit@bugs.x2go.org. (Mon, 15 Sep 2014 16:40:02 GMT) (full text, mbox, link).


Changed Bug title to 'X2Go Client for Windows cannot create C:\Users\<username>\ssh\known_hosts file when the username has non-English characters' from '"X2Go Client for Windows cannot create' Request was from Michael DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Tue, 16 Sep 2014 00:15:01 GMT) (full text, mbox, link).


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 16 Sep 2014 03:20:02 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 16 Sep 2014 03:20:02 GMT) (full text, mbox, link).


Message #95 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Subject: Ding! Build is ready
Date: Mon, 15 Sep 2014 23:18:27 -0400
George,

Please test this build or later:
http://code.x2go.org/releases/binary-win32/x2goclient/heuler/mingw32-4.8/qt-4.8/x2goclient-4.0.3.0-2014.09.16-2ffcad0-setup.exe

-Mike#2


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 16 Sep 2014 05:55:01 GMT) (full text, mbox, link).


Acknowledgement sent to Γεώργιος Τρακατέλης <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 16 Sep 2014 05:55:01 GMT) (full text, mbox, link).


Message #100 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Γεώργιος Τρακατέλης <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>, <mike.gabriel@das-netzwerkteam.de>, <uribepnr@gmail.com>
Subject: RE: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Tue, 16 Sep 2014 08:50:37 +0300
Dear Mike,

Two things.

1. Please make a preview build of X2Go Client for Windows with the patch applied and inform me when you do so.
I'd rather test a complete preview package of X2Go Client 4.0.3.0 for Windows.

2. Before writing this reply I had a recollection of initially having bumped onto a similar bug that was dismissed 
due to the fact that the submitter's system was not POSIX compliant. I searched for the bug but I couldn't find it.

Then I decided to give bug #566 a try on Linux, but Ubuntu 14.04 does not allow non-Ascii characters in user names.
After that, I did a more thorough search and finally found the aforementioned bug. It is bug #397!
I'm wondering why that bug was filed as an x2goserver bug instead of x2goclient.

The good news: I managed to change my (linux test) home folder to /home/néstor using usermod
(changing to /home/Γιώργος is impossible (Γιώργος=George in Greek)).
Findings: x2goclient managed to create known_hosts but the nxproxy module failed
"*** longjmp causes uninitialized stack frame ***: /user/lib/nx/bin/nxproxy terminated"

In bug #397, Néstor gives another reason for failure
"Error: The remote NX proxy closed the connection."
which implies x2goserver rejected the connection, so I stopped there.
Could you possibly test it? (If you cannot type an é, just copy-paste néstor)

-George

-----Original Message-----
From: Michael DePaulo [mailto:mikedep333@gmail.com] 
Sent: Monday, September 15, 2014 7:38 PM
To: 566@bugs.x2go.org
Cc: Michael Frederick; George Trakatelis
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters

Control: severity 566 grave

Dear George,

Thank you for your research.

Over the next day or so, I will apply bug566.test.v2.patch, which will then be included in both the MinGW 4.4 and the MinGW 4.8 nightly builds. Once you (or someone else) confirms that the patch fixes this bug for said installations, I will mark this bug as fixed. I've already cloned this bug. The clone will be for handling languages other than the "Language for non-Unicode programs"; i.e., using Unicode.

I am marking this original bug as severity "grave" because it "makes the package in question unusable or mostly so"[1] for a significant number of users. Getting this original bug fixed for x2goclient 4.0.3.0 will be a high priority for me.

Also, I tried to shorten the title of this bug (and correct a typo:
cannon -> cannot) but I ran into a bug with the debbugs software. I'm trying to correct the title.

-Mike



Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 16 Sep 2014 12:45:02 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 16 Sep 2014 12:45:02 GMT) (full text, mbox, link).


Message #105 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: 566@bugs.x2go.org
Cc: uribepnr@gmail.com, Γεώργιος Τρακατέλης <trakatelis@uom.edu.gr>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Tue, 16 Sep 2014 08:43:05 -0400
Hi George,

See inline responses.

On Tue, Sep 16, 2014 at 1:50 AM, Γεώργιος Τρακατέλης
<trakatelis@uom.edu.gr> wrote:
> Dear Mike,
>
> Two things.
>
> 1. Please make a preview build of X2Go Client for Windows with the patch applied and inform me when you do so.
> I'd rather test a complete preview package of X2Go Client 4.0.3.0 for Windows.

Done: 4.0.3.0-pre01.
The debug build is available too, and I manually updated the shortcuts
in the debug build.[1]
http://code.x2go.org/releases/binary-win32/x2goclient/previews/4.0.3.0/
I will now announce this on the mailing list.

> 2. Before writing this reply I had a recollection of initially having bumped onto a similar bug that was dismissed
> due to the fact that the submitter's system was not POSIX compliant. I searched for the bug but I couldn't find it.
>
> Then I decided to give bug #566 a try on Linux, but Ubuntu 14.04 does not allow non-Ascii characters in user names.
> After that, I did a more thorough search and finally found the aforementioned bug. It is bug #397!
> I'm wondering why that bug was filed as an x2goserver bug instead of x2goclient.

Bug #397 refers to when the user's home folder on the server has
non-Ascii characters. That is why the bug is filed against x2goserver.

Normally I would say that we should clone this bug (566) for X2Go
Client for Linux. However, the bug report is already extremely long, I
think we should just file a new one and link to this one. Could you
please file one?

> The good news: I managed to change my (linux test) home folder to /home/néstor using usermod
> (changing to /home/Γιώργος is impossible (Γιώργος=George in Greek)).
> Findings: x2goclient managed to create known_hosts but the nxproxy module failed
> "*** longjmp causes uninitialized stack frame ***: /user/lib/nx/bin/nxproxy terminated"
>
> In bug #397, Néstor gives another reason for failure
> "Error: The remote NX proxy closed the connection."
> which implies x2goserver rejected the connection, so I stopped there.
> Could you possibly test it? (If you cannot type an é, just copy-paste néstor)
>
> -George

1st of all, you were talking about a home dir with non-Ascii
characters on the client machine, correct? If so, that test is not
applicable to #397 for the aforementioned reason.

In order to properly test the fix for #397 on Ubuntu, we would have to
build a nightly build of x2goserver 4.0.1.16 or 4.1.0.0 from source.
It is not fixed in 4.0.1.15.

(AFAIK, there are no automated nightly x2goserver builds for Ubuntu.
Only for Debian, Fedora and EPEL.[2])

Besides, our "fix" for #397 is not to make homedirs with non-Ascii
characters "work". Our "fix" is to present a better error message and
cleanly abort the session.

-Mike#2

[1] http://wiki.x2go.org/doku.php/wiki:development:build-howto-mswin:x2goclient#build_x2go_client_from_source_debug_build
[2] http://jenkins.x2go.org:8080/view/Server/


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 16 Sep 2014 16:10:01 GMT) (full text, mbox, link).


Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 16 Sep 2014 16:10:02 GMT) (full text, mbox, link).


Message #110 received at 566@bugs.x2go.org (full text, mbox, reply):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Michael DePaulo'" <mikedep333@gmail.com>, <mike.gabriel@das-netzwerkteam.de>
Subject: RE: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Tue, 16 Sep 2014 19:09:44 +0300
Hi Mike,

First of all, patch bug566.test.v2.patch definitely solves the problem as described in bug #566. 
I have tried successfully both the release and the debug builds you uploaded 
both in Windows 8.1 Pro and Windows 7 Professional SP1 with all the Microsoft updates installed.

Now, with regard to bug #397:

> 1st of all, you were talking about a home dir with non-Ascii characters on the client machine, correct? 

Yes.

> Bug #397 refers to when the user's home folder on the server has non-Ascii characters. 
> That is why the bug is filed against x2goserver.
> Besides, our "fix" for #397 is not to make homedirs with non-Ascii characters "work". 
> Our "fix" is to present a better error message and cleanly abort the session.

I see.

> Normally I would say that we should clone this bug (566) for X2Go Client for Linux. 
> However, the bug report is already extremely long, 
> I think we should just file a new one and link to this one. Could you please file one?

I was only testing an analogous to bug #566 situation in Linux.
To be honest, I had to get round Ubuntu's policy for POSIX user names by using usermod. 
That test revealed that nxproxy (in Ubuntu 14.04) crashes when path names with non-Ascii characters are used,
but is it really a situation that deserves to be filed as a bug? 

I mean it's common for Windows users to have user names in their native language.
On the other hand, Ubuntu (and I suppose Unix in general) dictates 
exactly what characters are permitted in a user name.
If one by-passes this rule, erroneous program behavior may be observed.
Can we call it a bug of the program? I don’t know. You decide!
 
-George



Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Wed, 17 Sep 2014 11:45:01 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Wed, 17 Sep 2014 11:45:01 GMT) (full text, mbox, link).


Message #115 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: George Trakatelis <trakatelis@uom.edu.gr>
Cc: 566@bugs.x2go.org, Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Subject: Re: [X2Go-Dev] Bug#566: X2Go Client for Windows 4.0.2.1 cannot create C:\Users\<username>\ssh\known_hosts file when the local Windows account username has non-Ascii characters
Date: Wed, 17 Sep 2014 07:42:25 -0400
On Tue, Sep 16, 2014 at 12:09 PM, George Trakatelis
<trakatelis@uom.edu.gr> wrote:
> Hi Mike,
>
> First of all, patch bug566.test.v2.patch definitely solves the problem as described in bug #566.
> I have tried successfully both the release and the debug builds you uploaded
> both in Windows 8.1 Pro and Windows 7 Professional SP1 with all the Microsoft updates installed.

Great :)
I'll update debian/changelog. That update will mark this bug as
pending for release.

> Now, with regard to bug #397:
>
>> 1st of all, you were talking about a home dir with non-Ascii characters on the client machine, correct?
>
> Yes.
>
>> Bug #397 refers to when the user's home folder on the server has non-Ascii characters.
>> That is why the bug is filed against x2goserver.
>> Besides, our "fix" for #397 is not to make homedirs with non-Ascii characters "work".
>> Our "fix" is to present a better error message and cleanly abort the session.
>
> I see.
>
>> Normally I would say that we should clone this bug (566) for X2Go Client for Linux.
>> However, the bug report is already extremely long,
>> I think we should just file a new one and link to this one. Could you please file one?
>
> I was only testing an analogous to bug #566 situation in Linux.
> To be honest, I had to get round Ubuntu's policy for POSIX user names by using usermod.
> That test revealed that nxproxy (in Ubuntu 14.04) crashes when path names with non-Ascii characters are used,
> but is it really a situation that deserves to be filed as a bug?
>
> I mean it's common for Windows users to have user names in their native language.
> On the other hand, Ubuntu (and I suppose Unix in general) dictates
> exactly what characters are permitted in a user name.
> If one by-passes this rule, erroneous program behavior may be observed.
> Can we call it a bug of the program? I don’t know. You decide!
>
> -George

The way I see it, it is an "issue", not a "bug". You could also call
it a "limitation".

Still, we should show the user a better error message when a home dir
with non-english characters is detected on Linux. So please report a
bug about it.

-Mike#2


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Wed, 17 Sep 2014 11:45:02 GMT) (full text, mbox, link).


Acknowledgement sent to Mike DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Wed, 17 Sep 2014 11:45:02 GMT) (full text, mbox, link).


Message #120 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike DePaulo <mikedep333@gmail.com>
To: 566-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 566@bugs.x2go.org
Subject: X2Go issue (in src:x2goclient) has been marked as pending for release
Date: Wed, 17 Sep 2014 13:44:15 +0200 (CEST)
tag #566 pending
fixed #566 4.0.3.0
thanks

Hello,

X2Go issue #566 (src:x2goclient) reported by you has been
fixed in X2Go Git. You can see the changelog below, and you can
check the diff of the fix at:

    http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=0e3aff0

The issue will most likely be fixed in src:x2goclient (4.0.3.0).

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
commit 0e3aff054195de9eb09e7c280aca017f9e891c10
Author: Mike DePaulo <mikedep333@gmail.com>
Date:   Wed Sep 17 07:44:07 2014 -0400

    Update changelog: Last commit (2ffcad0) fixes bug #566

diff --git a/debian/changelog b/debian/changelog
index a58e2b3..00ff9c3 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -45,7 +45,7 @@ x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
   [ Mike DePaulo ]
   * New upstream release (4.0.3.0):
     - Windows: Fix not being able to add the server to the known_hosts file when
-      the username has non-English characters.
+      the username has non-English characters. (Fixes: #566)
       (NOTE: This fix only works when the non-English characters are in the same
       language as the Windows "system locale" AKA "Language for non-Unicode
       programs." Bug #611 was written for fixing the issue for languages other


Added tag(s) pending. Request was from Mike DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Wed, 17 Sep 2014 11:45:03 GMT) (full text, mbox, link).


Marked as fixed in versions 4.0.3.0. Request was from Mike DePaulo <mikedep333@gmail.com> to control@bugs.x2go.org. (Wed, 17 Sep 2014 11:45:03 GMT) (full text, mbox, link).


Message sent on to <trakatelis@uom.gr>:
Bug#566. (Wed, 17 Sep 2014 11:45:03 GMT) (full text, mbox, link).


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Thu, 09 Oct 2014 17:25:01 GMT) (full text, mbox, link).


Acknowledgement sent to "George Trakatelis" <trakatelis@uom.edu.gr>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Thu, 09 Oct 2014 17:25:02 GMT) (full text, mbox, link).


Message #132 received at 566@bugs.x2go.org (full text, mbox, reply):

From: "George Trakatelis" <trakatelis@uom.edu.gr>
To: <566@bugs.x2go.org>
Cc: "'Mike DePaulo'" <mikedep333@gmail.com>
Subject: RE: Bug#566: X2Go issue (in src:x2goclient) has been marked as pending for release
Date: Thu, 9 Oct 2014 20:20:41 +0300
[Message part 1 (text/plain, inline)]
Dear Michael, 

With regard to bug #566 and proposed patch bug566.test.v2.patch, 
please review a minor addition of mine to the aforementioned patch 
which aids debugging of x2goclient. 

With bug566.test.v2.patch applied, 
SSH_OPTIONS_SSH_DIR is correctly set in X2GoFree for Windows 
but its new value is not passed to x2goDebug. 
Attached bug566.aid-debugging.patch corrects just that. 

-- George


-----Original Message-----
From: Mike DePaulo [mailto:mikedep333@gmail.com] 
Sent: Wednesday, September 17, 2014 2:44 PM
To: 566-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org; 566@bugs.x2go.org
Subject: Bug#566: X2Go issue (in src:x2goclient) has been marked as pending for release

tag #566 pending
fixed #566 4.0.3.0
thanks

Hello,

X2Go issue #566 (src:x2goclient) reported by you has been fixed in X2Go Git. 

You can see the changelog below, and you can check the diff of the fix at:

    http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=0e3aff0

The issue will most likely be fixed in src:x2goclient (4.0.3.0).

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
commit 0e3aff054195de9eb09e7c280aca017f9e891c10
Author: Mike DePaulo <mikedep333@gmail.com>
Date:   Wed Sep 17 07:44:07 2014 -0400

    Update changelog: Last commit (2ffcad0) fixes bug #566

diff --git a/debian/changelog b/debian/changelog index a58e2b3..00ff9c3 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -45,7 +45,7 @@ x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
   [ Mike DePaulo ]
   * New upstream release (4.0.3.0):
     - Windows: Fix not being able to add the server to the known_hosts file when
-      the username has non-English characters.
+      the username has non-English characters. (Fixes: #566)
       (NOTE: This fix only works when the non-English characters are in the same
       language as the Windows "system locale" AKA "Language for non-Unicode
       programs." Bug #611 was written for fixing the issue for languages other
[bug566.aid-debugging.patch (application/octet-stream, attachment)]

Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Sat, 11 Oct 2014 10:35:01 GMT) (full text, mbox, link).


Acknowledgement sent to Michael DePaulo <mikedep333@gmail.com>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Sat, 11 Oct 2014 10:35:01 GMT) (full text, mbox, link).


Message #137 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Michael DePaulo <mikedep333@gmail.com>
To: George Trakatelis <trakatelis@uom.edu.gr>
Cc: 566@bugs.x2go.org
Subject: Re: Bug#566: X2Go issue (in src:x2goclient) has been marked as pending for release
Date: Sat, 11 Oct 2014 06:33:48 -0400
Thanks! Applied.

On Thu, Oct 9, 2014 at 1:20 PM, George Trakatelis <trakatelis@uom.edu.gr> wrote:
> Dear Michael,
>
> With regard to bug #566 and proposed patch bug566.test.v2.patch,
> please review a minor addition of mine to the aforementioned patch
> which aids debugging of x2goclient.
>
> With bug566.test.v2.patch applied,
> SSH_OPTIONS_SSH_DIR is correctly set in X2GoFree for Windows
> but its new value is not passed to x2goDebug.
> Attached bug566.aid-debugging.patch corrects just that.
>
> -- George
>
>
> -----Original Message-----
> From: Mike DePaulo [mailto:mikedep333@gmail.com]
> Sent: Wednesday, September 17, 2014 2:44 PM
> To: 566-submitter@bugs.x2go.org
> Cc: control@bugs.x2go.org; 566@bugs.x2go.org
> Subject: Bug#566: X2Go issue (in src:x2goclient) has been marked as pending for release
>
> tag #566 pending
> fixed #566 4.0.3.0
> thanks
>
> Hello,
>
> X2Go issue #566 (src:x2goclient) reported by you has been fixed in X2Go Git.
>
> You can see the changelog below, and you can check the diff of the fix at:
>
>     http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=0e3aff0
>
> The issue will most likely be fixed in src:x2goclient (4.0.3.0).
>
> light+love
> X2Go Git Admin (on behalf of the sender of this mail)
>
> ---
> commit 0e3aff054195de9eb09e7c280aca017f9e891c10
> Author: Mike DePaulo <mikedep333@gmail.com>
> Date:   Wed Sep 17 07:44:07 2014 -0400
>
>     Update changelog: Last commit (2ffcad0) fixes bug #566
>
> diff --git a/debian/changelog b/debian/changelog index a58e2b3..00ff9c3 100644
> --- a/debian/changelog
> +++ b/debian/changelog
> @@ -45,7 +45,7 @@ x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
>    [ Mike DePaulo ]
>    * New upstream release (4.0.3.0):
>      - Windows: Fix not being able to add the server to the known_hosts file when
> -      the username has non-English characters.
> +      the username has non-English characters. (Fixes: #566)
>        (NOTE: This fix only works when the non-English characters are in the same
>        language as the Windows "system locale" AKA "Language for non-Unicode
>        programs." Bug #611 was written for fixing the issue for languages other


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 21 Oct 2014 11:30:08 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 21 Oct 2014 11:30:08 GMT) (full text, mbox, link).


Message #142 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 566-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 566@bugs.x2go.org
Subject: X2Go issue (in src:x2goclient) has been marked as pending for release
Date: Tue, 21 Oct 2014 13:26:04 +0200 (CEST)
tag #566 pending
fixed #566 4.0.3.0
thanks

Hello,

X2Go issue #566 (src:x2goclient) reported by you has been
fixed in X2Go Git. You can see the changelog below, and you can
check the diff of the fix at:

    http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=bfd6f53

The issue will most likely be fixed in src:x2goclient (4.0.3.0).

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
commit bfd6f535869f9b6cc8da6979c6f03db91a32a983
Author: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
Date:   Tue Oct 21 12:42:21 2014 +0200

    release 4.0.3.0

diff --git a/debian/changelog b/debian/changelog
index a57b7ce..b371345 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,4 +1,4 @@
-x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
+x2goclient (4.0.3.0-0x2go1) unstable; urgency=low
 
   [ Mike Gabriel ]
   * New upstream release (4.0.3.0):
@@ -32,7 +32,7 @@ x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
     - Fix running x2goclient without arguments on Windows. (Fixes: #522).
     - Save proxy output in $HOME/S-$SESSION-ID/session.log if debugging is
       enabled.
-    - Fork x2goclient on windows and terminate child processes if x2go client
+    - Fork x2goclient on windows and terminate child processes if X2Go Client
       crashed. (Fixes: #159).
     - Add "clipboard" parameter to session profile and to command line options.
       (Fixes: #258).
@@ -49,12 +49,12 @@ x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
       x2gohelper.
     - Add Makefile for x2gohelper.
     - Add support for sessions folders.
-    - Add folder explorer - GUI to management of sessions folders.
-    - Support for sessions folders in sessionmanagedialog.
-    - Session name autocomplition only for sessions in current folder.
-    - Support for sessions folders and commandline options "--session"
+    - Add folder explorer: a GUI to manage of session subfolders.
+    - Support for sessions subfolders in sessionmanagedialog.
+    - Session name autocompletion only for sessions in current folder.
+    - Support for session subfolders and command-line options "--session"
       and "--sessionid".
-    - Disable sessions explorer "back" button if user sessions disabled.
+    - Disable session explorer "back" button if user sessions are disabled.
     - Include <QDir> in sessionexplorer.cpp.
     - Remove deprecated workaround in wapi.cpp.
     - Save folder icons Base64 coded. Save icons under General\icon_<PATH>.
@@ -150,7 +150,38 @@ x2goclient (4.0.3.0-0x2go1) UNRELEASED; urgency=low
   * New upstream version (4.0.3.0):
     - Update Swedish translation file.
 
- -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Thu, 10 Apr 2014 18:30:25 +0200
+  * Translation status:
+    OK - Updating 'x2goclient/x2goclient_de.qm'...
+      Generated 566 translation(s) (566 finished and 0 unfinished)
+    INCOMPLETE - Updating 'x2goclient/x2goclient_da.qm'...
+      Generated 536 translation(s) (526 finished and 10 unfinished)
+      Ignored 30 untranslated source text(s)
+    OK - Updating 'x2goclient/x2goclient_es.qm'...
+      Generated 566 translation(s) (566 finished and 0 unfinished)
+    OK - Updating 'x2goclient/x2goclient_et.qm'...
+      Generated 566 translation(s) (566 finished and 0 unfinished)
+    OK - Updating 'x2goclient/x2goclient_fi.qm'...
+      Generated 566 translation(s) (566 finished and 0 unfinished)
+    INCOMPLETE - Updating 'x2goclient/x2goclient_fr.qm'...
+      Generated 254 translation(s) (201 finished and 53 unfinished)
+      Ignored 312 untranslated source text(s)
+    OK - Updating 'x2goclient/x2goclient_nb_no.qm'...
+       Generated 566 translation(s) (566 finished and 0 unfinished)
+    OK - Updating 'x2goclient/x2goclient_nl.qm'...
+      Generated 566 translation(s) (566 finished and 0 unfinished)
+    UNTRANSLATED - Updating 'x2goclient/x2goclient_pt.qm'...
+      Generated 0 translation(s) (0 finished and 0 unfinished)
+      Ignored 566 untranslated source text(s)
+    INCOMPLETE - Updating 'x2goclient/x2goclient_ru.qm'...
+      Generated 552 translation(s) (543 finished and 9 unfinished)
+      Ignored 14 untranslated source text(s)
+    OK - Updating 'x2goclient/x2goclient_sv.qm'...
+      Generated 566 translation(s) (566 finished and 0 unfinished)
+    INCOMPLETE - Updating 'x2goclient/x2goclient_zh_tw.qm'...
+      Generated 397 translation(s) (372 finished and 25 unfinished)
+      Ignored 169 untranslated source text(s)
+
+ -- Mike Gabriel <mike.gabriel@das-netzwerkteam.de>  Tue, 21 Oct 2014 12:38:56 +0200
 
 x2goclient (4.0.2.1-0x2go1) unstable; urgency=low
 


Information forwarded to x2go-dev@lists.x2go.org, X2Go Developers <x2go-dev@lists.x2go.org>:
Bug#566; Package x2goclient. (Tue, 21 Oct 2014 11:30:09 GMT) (full text, mbox, link).


Acknowledgement sent to Mike Gabriel <mike.gabriel@das-netzwerkteam.de>:
Extra info received and forwarded to list. Copy sent to X2Go Developers <x2go-dev@lists.x2go.org>. (Tue, 21 Oct 2014 11:30:09 GMT) (full text, mbox, link).


Message #147 received at 566@bugs.x2go.org (full text, mbox, reply):

From: Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
To: 566-submitter@bugs.x2go.org
Cc: control@bugs.x2go.org, 566@bugs.x2go.org
Subject: X2Go issue (in src:x2goclient) has been marked as closed
Date: Tue, 21 Oct 2014 13:26:11 +0200 (CEST)
close #566
thanks

Hello,

we are very hopeful that X2Go issue #566 reported by you
has been resolved in the new release (4.0.3.0) of the
X2Go source project »src:x2goclient«.

You can view the complete changelog entry of src:x2goclient (4.0.3.0)
below, and you can use the following link to view all the code changes
between this and the last release of src:x2goclient.

    http://code.x2go.org/gitweb?p=x2goclient.git;a=commitdiff;h=04ed56d4162f000b093bea13aa2582c2de718144;hp=85bf0c6e7539910fff779689528009a897cdceb4

If you feel that the issue has not been resolved satisfyingly, feel
free to reopen this bug report or submit a follow-up report with
further observations described based on the new released version
of src:x2goclient.

Thanks a lot for contributing to X2Go!!!

light+love
X2Go Git Admin (on behalf of the sender of this mail)

---
X2Go Component: src:x2goclient
Version: 4.0.3.0-0x2go1
Status: RELEASE
Date: Tue, 21 Oct 2014 12:38:56 +0200
Fixes: 108 159 253 258 336 474 522 525 566 568 571 580 587 590 597 603 607 608 609 612 636
Changes: 
 x2goclient (4.0.3.0-0x2go1) RELEASED; urgency=low
 .
   [ Mike Gabriel ]
   * New upstream release (4.0.3.0):
     - Disallow server-side users to override X2Go Server commands via
       ~/bin (or similar). (Fixes: #336).
     - Avoid unitialised variables on early calls of ONMainWindow::closeEvent()
       or ONMainWindow::closeClient(). (Fixes: #253).
     - Update translation files. Add empty Portuguese translation. Update
       qt_<lang>.qm files from Debian unstable as of today.
     - Update German translation file (after session folder feature got added).
     - Makefile.man2html: Test if man2html exists. If not, don't fail.
     - Honor exports (client-side shared folders) from broker session profiles.
       Thanks to Ming Song for providing a patch for this (Fixes: 612).
   * debian/control:
     + Add B-D: apache2-dev. On squeeze / lucid builds, this is a superfluous
       B-D, but for later Debian/Ubuntu versions, this smoothes the installation
       of the x2goplugin-provide bin:package.
     + Update B-D: apache2-dev | libc6-dev. The apache2-dev package does not
       exist on all Debian/Ubuntu versions.
   * x2goclient.spec:
     + Adapt to building for openSUSE/SLES.
     + openSUSE: Make Qt4 Linguist tools available for Makefile.
     + Upgrade versioned BR for libssh-devel (0.6.3 or patched 0.5.5).
     + The libqt4-linguist split off happened in openSUSE 13.1.
     + Add x2goclient-rpmlintrc file.
     + In openSUSE, it is openldap2-devel, in Fedora/RHEL it is openldap-devel.
     + In openSUSE, openssh is openssh (not openssh-clients / openssh-server).
 .
   [ Oleksandr Shneyder ]
   * New upstream release (4.0.3.0):
     - Fix running x2goclient without arguments on Windows. (Fixes: #522).
     - Save proxy output in $HOME/S-$SESSION-ID/session.log if debugging is
       enabled.
     - Fork x2goclient on windows and terminate child processes if X2Go Client
       crashed. (Fixes: #159).
     - Add "clipboard" parameter to session profile and to command line options.
       (Fixes: #258).
     - Replace qCritical() with printError() by argument parsing.
     - Update translation files.
     - Update russian translation.
     - Update string "&Clipboard Mode" and translate in russian translation file.
     - Grammar fix in russian translation.
     - Add x2gohelper to start X2Go Client on Windows and clean child processes
       if X2Go Client crashes. (Fixes: #525).
     - On Windows rename x2goclient.exe to x2goclient-mainprocess.exe and
       x2gohelper.exe to x2goclient.exe.
     - Start x2gohelper from X2Go Client. Revert name changing of X2Go Client and
       x2gohelper.
     - Add Makefile for x2gohelper.
     - Add support for sessions folders.
     - Add folder explorer: a GUI to manage of session subfolders.
     - Support for sessions subfolders in sessionmanagedialog.
     - Session name autocompletion only for sessions in current folder.
     - Support for session subfolders and command-line options "--session"
       and "--sessionid".
     - Disable session explorer "back" button if user sessions are disabled.
     - Include <QDir> in sessionexplorer.cpp.
     - Remove deprecated workaround in wapi.cpp.
     - Save folder icons Base64 coded. Save icons under General\icon_<PATH>.
       (Fixes: #580).
     - Fix placing sessions folders in broker mode.
     - Fix onmainwindow.cpp after 76ae96781f1d2d5754ee4751539d5de47f1d0297.
     - Add support for session selection in broker mode.
 .
   [ Mike DePaulo ]
   * New upstream release (4.0.3.0):
     - Make X2Go Client aware of the Cinnamon (CINNAMON) desktop environment.
       (Fixes: #571)
     - Make X2Go Client aware of the Trinity (TRINITY) desktop environment.
       (Fixes: #609)
     - Make X2Go Client aware of the Openbox (OPENBOX) window manager.
       (Fixes: #607)
     - Make X2Go Client aware of the IceWM (ICEWM) window manager.
       (Fixes: #608)
     - Windows: Fix not being able to add the server to the known_hosts file when
       the username has non-English characters. (Fixes: #566)
       (NOTE: This fix only works when the non-English characters are in the same
       language as the Windows "system locale" AKA "Language for non-Unicode
       programs." Bug #611 was written for fixing the issue for languages other
       than the system locale.)
       Thanks George Trakatelis (uom.edu.gr) for submitting part of this fix.
     - Windows: Install VcXsrv "misc" fonts by default, and make all 4 font
       groups optional: misc, 75dpi, 100dpi and others (Fixes: #108)
       Note: The fact that all the fonts are included makes the installer about
       30MB larger.
     - Windows: Bundle new version of VcXsrv: 1.15.2.1-xp+vc2013+x2go1
       This new version is based on upstream VcXsrv 1.15.2.0, but still
       compatible with Windows XP. It also has its bundled OpenSSL updated to
       1.0.1j. It is compiled with Microsoft Visual C++ 2013 and contains 1
       X2Go-specific change, winmultiwindow.patch. This patch fixes an issue
       when resizing the NX-proxy window on specific multiple monitor setups.
       (Thanks Oleksandr Shneyder for the patch) (Fixes: #568) (Fixes: #594)
     - Windows: Port from MinGW 4.4 + Qt 4.8.5 to MinGW 4.8.2 + Qt 4.8.6,
       including fix for QTBUG-38706 (Fixes: #474, #603)
     - Windows: Fix missing VcXsrv/zlib1.dll . The impact of this bug was that
       VcXsrv would not start if the cwd was changed from the x2goclient
       directory. (The start menu and desktop shortcuts do have the x2goclient
       directory as the cwd. So they were not affected.) (Fixes: #587)
     - Windows: Make the desktop shortcut optional during install,
       but still the default.
     - Windows: Upgrade libssh from 0.5.5 to 0.6.3. This fixes connecting to
       hpn-enabled SSH servers. The Pageant support patch from the KDE Windows
       project was ported to 0.6.3 by myself and Mike Frederick.
       (Gmail: psududemike) (Fixes: #590)
     - Windows: Win32 OpenSSL updated from 1.0.1h to 1.0.1j, which fixes the
       CVEs announced on 2014-08-06 & 2014-10-15.
     - Windows: Replace Cygwin Bash (sh.exe) with Cygwin Dash (ash.exe renamed
       to sh.exe). This also means fewer Cygwin .DLLs are bundled.
       (Fixes: #636)
     - Windows: cygwin packages (excluding OpenSSH, which is at the patched
       version of 6.6.1p1-3-x2go1) updated from latest versions as of 2014-06-09
       to latest versions as of 2014-10-18. This includes openssl 1.0.1j-1, which
       fixes the CVEs announced on 2014-08-06 & 2014-10.15.
       (Cygwin openssl was also individually updated in 4.0.2.1+hotfix1+build2,
       but only to 1.0.1i-1.)
     - Windows: Build nxproxy.exe with Cygwin's libpng 1.5.x rather than 1.2.x.
       (This may improve performance when PNG compression is selected.)
     - Windows: Build cygwin openssh without krb5 or tcp_wrappers support because
       X2Go Client for Windows does not use either feature.
       (On Windows, Kerberos 5 (GSSAPI) support is provided by PuTTY.)
     - Windows: Fix text not being rendered properly at end of NSIS installer
       (Fixes: #597)
 .
   [ Stefan Baur ]
   * New upstream version (4.0.3.0):
     - Update German translation file.
 .
   [ Ricardo Díaz Martín ]
   * New upstream version (4.0.3.0):
     - Update Spanish translation file.
 .
   [ Martti Pitkanen ]
   * New upstream version (4.0.3.0):
     - Update Finnish translation file.
 .
   [ Jos Wolfram ]
   * New upstream version (4.0.3.0):
     - Update Dutch translation file.
 .
   [ Robert Parts ]
   * New upstream version (4.0.3.0):
     - Add Estonian translation file.
 .
   [ Klaus Ade Johnstad ]
   * New upstream version (4.0.3.0):
     - Update Bokmal (Norway) translation file.
 .
   [ Daniel Lindgren ]
   * New upstream version (4.0.3.0):
     - Update Swedish translation file.
 .
   * Translation status:
     OK - Updating 'x2goclient/x2goclient_de.qm'...
       Generated 566 translation(s) (566 finished and 0 unfinished)
     INCOMPLETE - Updating 'x2goclient/x2goclient_da.qm'...
       Generated 536 translation(s) (526 finished and 10 unfinished)
       Ignored 30 untranslated source text(s)
     OK - Updating 'x2goclient/x2goclient_es.qm'...
       Generated 566 translation(s) (566 finished and 0 unfinished)
     OK - Updating 'x2goclient/x2goclient_et.qm'...
       Generated 566 translation(s) (566 finished and 0 unfinished)
     OK - Updating 'x2goclient/x2goclient_fi.qm'...
       Generated 566 translation(s) (566 finished and 0 unfinished)
     INCOMPLETE - Updating 'x2goclient/x2goclient_fr.qm'...
       Generated 254 translation(s) (201 finished and 53 unfinished)
       Ignored 312 untranslated source text(s)
     OK - Updating 'x2goclient/x2goclient_nb_no.qm'...
        Generated 566 translation(s) (566 finished and 0 unfinished)
     OK - Updating 'x2goclient/x2goclient_nl.qm'...
       Generated 566 translation(s) (566 finished and 0 unfinished)
     UNTRANSLATED - Updating 'x2goclient/x2goclient_pt.qm'...
       Generated 0 translation(s) (0 finished and 0 unfinished)
       Ignored 566 untranslated source text(s)
     INCOMPLETE - Updating 'x2goclient/x2goclient_ru.qm'...
       Generated 552 translation(s) (543 finished and 9 unfinished)
       Ignored 14 untranslated source text(s)
     OK - Updating 'x2goclient/x2goclient_sv.qm'...
       Generated 566 translation(s) (566 finished and 0 unfinished)
     INCOMPLETE - Updating 'x2goclient/x2goclient_zh_tw.qm'...
       Generated 397 translation(s) (372 finished and 25 unfinished)
       Ignored 169 untranslated source text(s)


Marked Bug as done Request was from Mike Gabriel <mike.gabriel@das-netzwerkteam.de> to control@bugs.x2go.org. (Tue, 21 Oct 2014 11:30:22 GMT) (full text, mbox, link).


Notification sent to <trakatelis@uom.gr>:
Bug acknowledged by developer. (Tue, 21 Oct 2014 11:30:22 GMT) (full text, mbox, link).


Message sent on to <trakatelis@uom.gr>:
Bug#566. (Tue, 21 Oct 2014 11:30:43 GMT) (full text, mbox, link).


Message sent on to <trakatelis@uom.gr>:
Bug#566. (Tue, 21 Oct 2014 11:30:44 GMT) (full text, mbox, link).


Bug archived. Request was from Debbugs Internal Request <owner@bugs.x2go.org> to internal_control@bugs.x2go.org. (Wed, 19 Nov 2014 06:24:02 GMT) (full text, mbox, link).


Send a report that this bug log contains spam.


X2Go Developers <owner@bugs.x2go.org>. Last modified: Fri Dec 13 00:46:43 2019; Machine Name: ymir.das-netzwerkteam.de

X2Go Bug tracking system

Debbugs is free software and licensed under the terms of the GNU Public License version 2. The current version can be obtained from https://bugs.debian.org/debbugs-source/.

Copyright © 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson, 2005-2017 Don Armstrong, and many other contributors.